Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 18084)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 18085)
@@ -164,4 +164,7 @@
     <Compile Include="Interfaces\ILocalImprovementAlgorithmOperator.cs" />
     <Compile Include="Interfaces\IMultiObjectiveOperator.cs" />
+    <Compile Include="Parameters\AlgorithmLookupParameter.cs" />
+    <Compile Include="Parameters\MultiObjectiveProblemLookupParameter.cs" />
+    <Compile Include="Parameters\ProblemLookupParameter.cs" />
     <Compile Include="Results\IResultsProducingItem.cs" />
     <Compile Include="MultiObjective\CrowdingCalculator.cs" />
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/AlgorithmLookupParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/AlgorithmLookupParameter.cs	(revision 18085)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/AlgorithmLookupParameter.cs	(revision 18085)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Optimization {
+  [Item("AlgorithmLookupParameter", "A parameter that looks up algorithms by type.")]
+  [StorableType("8d34b2ba-5fb3-4be0-915a-cfa18d2bc1a9")]
+  public class AlgorithmLookupParameter : ContextLookupParameter<Algorithm> {
+
+    [StorableConstructor]
+    protected AlgorithmLookupParameter(StorableConstructorFlag _) : base(_) { }
+    protected AlgorithmLookupParameter(AlgorithmLookupParameter original, Cloner cloner) : base(original, cloner) { }
+    public AlgorithmLookupParameter() : base() { }
+    public AlgorithmLookupParameter(string name) : base(name) { }
+    public AlgorithmLookupParameter(string name, string description) : base(name, description) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new AlgorithmLookupParameter(this, cloner);
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/MultiObjectiveProblemLookupParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/MultiObjectiveProblemLookupParameter.cs	(revision 18085)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/MultiObjectiveProblemLookupParameter.cs	(revision 18085)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Optimization {
+  [Item("MultiObjectiveProblemLookupParameter", "A parameter that looks up multi-objective problems with a given encoding by type.")]
+  [StorableType("bb66b77c-12bd-4024-ad97-99c70489c2ee")]
+  public class MultiObjectiveProblemLookupParameter<TEncoding, TEncodedSolution> : ContextLookupParameter<SingleObjectiveProblem<TEncoding, TEncodedSolution>>
+    where TEncoding : class, IEncoding
+    where TEncodedSolution : class, IEncodedSolution {
+
+    [StorableConstructor]
+    protected MultiObjectiveProblemLookupParameter(StorableConstructorFlag _) : base(_) { }
+    protected MultiObjectiveProblemLookupParameter(MultiObjectiveProblemLookupParameter<TEncoding, TEncodedSolution> original, Cloner cloner) : base(original, cloner) { }
+    public MultiObjectiveProblemLookupParameter() : base() { }
+    public MultiObjectiveProblemLookupParameter(string name) : base(name) { }
+    public MultiObjectiveProblemLookupParameter(string name, string description) : base(name, description) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MultiObjectiveProblemLookupParameter<TEncoding, TEncodedSolution>(this, cloner);
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/ProblemLookupParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/ProblemLookupParameter.cs	(revision 18085)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Parameters/ProblemLookupParameter.cs	(revision 18085)
@@ -0,0 +1,45 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Optimization {
+  [Item("ProblemLookupParameter", "A parameter that looks up single-objective problems with a given encoding by type.")]
+  [StorableType("d7b99bd8-616d-4ff3-90f8-7c4291a77690")]
+  public class ProblemLookupParameter<TEncoding, TEncodedSolution> : ContextLookupParameter<SingleObjectiveProblem<TEncoding, TEncodedSolution>>
+    where TEncoding: class, IEncoding
+    where TEncodedSolution: class, IEncodedSolution {
+
+    [StorableConstructor]
+    protected ProblemLookupParameter(StorableConstructorFlag _) : base(_) { }
+    protected ProblemLookupParameter(ProblemLookupParameter<TEncoding, TEncodedSolution> original, Cloner cloner) : base(original, cloner) { }
+    public ProblemLookupParameter() : base() { }
+    public ProblemLookupParameter(string name) : base(name) { }
+    public ProblemLookupParameter(string name, string description) : base(name, description) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ProblemLookupParameter<TEncoding, TEncodedSolution>(this, cloner);
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/ContextLookupParameter.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/ContextLookupParameter.cs	(revision 18084)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Parameters/3.3/ContextLookupParameter.cs	(revision 18085)
@@ -7,5 +7,5 @@
   [Item("ContextLookupParameter", "A parameter that looks up contexts by type.")]
   [StorableType("4ac189c8-6cf3-48fd-bf79-392d35a872db")]
-  public class ContextLookupParameter<T> : ContextParameter, IContextLookupParameter<T>
+  public abstract class ContextLookupParameter<T> : ContextParameter, IContextLookupParameter<T>
       where T : class, IParameterizedItem {
 
@@ -17,10 +17,8 @@
     protected ContextLookupParameter(StorableConstructorFlag _) : base(_) { }
     protected ContextLookupParameter(ContextLookupParameter<T> original, Cloner cloner) : base(original, cloner) { }
-    public ContextLookupParameter() : base("ContextLookup." + typeof(T).Name, string.Empty, typeof(T)) {
+    protected ContextLookupParameter() : this("ContextLookup." + typeof(T).Name) { }
+    protected ContextLookupParameter(string name) : this(name, string.Empty) { }
+    protected ContextLookupParameter(string name, string description) : base(name, description, typeof(T)) {
       Hidden = true;
-    }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new ContextLookupParameter<T>(this, cloner);
     }
 